// del.icio.us post 0.4
// Created by Patrick H. Lauke aka redux - http://www.splintered.co.uk - April 2005
// scuttlelicious
// modified by Kai Mai - http://www.kai-mai.com - Oct 2005.

// global variables

var delicious_post_stringbundle;

var scuttlelicious_chrome_url = "chrome://scuttlelicious/";

const scuttlelicious_preferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

function delicious_post_dialog_init() {
	
	var username='';
	var password='';
	

	try {
		if (scuttlelicious_preferences.prefHasUserValue('delicious.post.username')) {
			username=scuttlelicious_preferences.getCharPref('delicious.post.username');
			if (scuttlelicious_preferences.getBoolPref('delicious.post.use_password_manager')==true) {
				password = delicious_getPassword(username);
				document.getElementById('delicious-post-dialog-password').setAttribute('value',password);
				document.getElementById('delicious-post-dialog-use_password_manager').setAttribute('checked',true);
			}
		}
	} catch (ex)
	{
		scuttlelicious_preferences.setBoolPref('delicious.post.use_password_manager',false);
	}
	

	var description=window.arguments[1]; // this is passed to the dialog by the delicious_post_submit() function in context.js
	var url=window.arguments[0]; 
	/*
	dump("delicious_ post_url " + url);
	dump("\ndelicious_ post_description " + description);
	dump("\n");
	*/
	
	// set the values in the dialog
	document.getElementById('delicious-post-dialog-username').setAttribute('value',username);

	document.getElementById('delicious-post-dialog-url').setAttribute('value',url);
	document.getElementById('delicious-post-dialog-description').setAttribute('value',description);
	
	scuttlelicious_loadPrivacyPref();
	scuttlelicious_autofillServiceURL();
}

function scuttlelicious_loadPrivacyPref(){
	var privacy = -1;
	
	try{
		privacy = scuttlelicious_preferences.getIntPref("scuttlelicious_privacy_preference");
		dump("stored privacy value scuttlelicious_loadPrivacyPref: " + privacy + "\n");
	}catch(e){
		dump("exception in scuttlelicious_loadPrivacyPref: " + e + "\n");
		privacy = -1;
	}
	document.getElementById('scuttlelicious-privacy-preference').selectedIndex = privacy;
	document.getElementById('scuttlelicious-privacy-code').selectedIndex = privacy;
}


function scuttlelicious_get_privacy_level(privacyGroup){
	var selectedPrivacy = privacyGroup.selectedIndex;

//	dump("selectedPrivacy " + selectedPrivacy + "\n");

	return selectedPrivacy;
	
	/*
	if(!selectedPrivacy)
		return 0;
	//dump("selectedPrivacy.id: " + selectedPrivacy.id + "\n");	
	if(selectedPrivacy.id == 'scuttlelicious-privacy-code-watched_list')
		return 1;
	if(selectedPrivacy.id == 'scuttlelicious-privacy-code-private')
		return 2;

	return 0;
			*/
}

function delicious_post_dialog_accept() {
	// general stuff
	//var api_url='http://del.icio.us/api/';
	//var api_url='http://scuttle.org/api/';
	
	var bundle=document.getElementById('delicious-post-stringbundle');
	
	// get values entered in the form
	var username=encodeURIComponent(document.getElementById('delicious-post-dialog-username').value);
	var password=encodeURIComponent(document.getElementById('delicious-post-dialog-password').value);
	var url=encodeURIComponent(document.getElementById('delicious-post-dialog-url').value);
	var description=encodeURIComponent(document.getElementById('delicious-post-dialog-description').value);
	var extended=encodeURIComponent(document.getElementById('delicious-post-dialog-extended').value);
	
	var tags=document.getElementById('delicious-post-dialog-tags').value;
	// on the web interface, users use "," as the delimeter, but for the API, the delimeter is " "
	tags = tags.replace(/,/g," ");
//	dump(tags + "\n");
	
	tags = encodeURIComponent(tags);
	
	var service_url=document.getElementById('delicious-post-dialog-service-url').value;
//	dump(service_url + "\n");
	
	
	service_url	= encodeURI(service_url);
//	dump(service_url + "\n");

	

	// handle the login saving stuff first
    const preferencesService = scuttlelicious_preferences;

	preferencesService.setCharPref('delicious.post.username',username);
	preferencesService.setCharPref('scuttlelicious_host', service_url);
	preferencesService.setIntPref('scuttlelicious_privacy_preference', scuttlelicious_get_privacy_level(document.getElementById('scuttlelicious-privacy-preference')));
	
	var api_dir = "api";
	var base_api_url = scuttlelicious_getServiceURL() + "/" + api_dir;
	var api_url = base_api_url + "/posts_add.php?";

	if (document.getElementById('delicious-post-dialog-use_password_manager').checked==true) {
		delicious_savePassword(username,password,true);
		preferencesService.setBoolPref('delicious.post.use_password_manager',true);
	} else {
		delicious_savePassword(username,'',false);
		preferencesService.setBoolPref('delicious.post.use_password_manager',false);
	}

	// minimal sanity check
	if ((username=='')||(password=='')) {
		alert(bundle.getString('supplylogin'));
		document.getElementById('delicious-post-dialog-tabbox').selectedIndex=1;
		return false;
	} else {
		
		// temporarily disable accept/cancel buttons and show the progressmeter deck (so user knows something's happening)
		document.getElementById('delicious-post-dialog-deck').selectedIndex=1;

		document.getElementById('delicious-post-dialog').setAttribute('wait-cursor',true);
		document.getElementById('delicios-post-dialog-accept').disabled=true;
		document.getElementById('delicios-post-dialog-cancel').disabled=false;
		
		// work out the correct ISO datestamp (no need for timezone offset, we're using UTC throughout)
		var d = new Date();
		var isodatestamp = delicious_post_pad0(d.getUTCFullYear(),4)+'-'+delicious_post_pad0((d.getUTCMonth()+1),2)+'-'+delicious_post_pad0(d.getUTCDate(),2)+'T'+delicious_post_pad0(d.getUTCHours(),2)+':'+delicious_post_pad0(d.getUTCMinutes(),2)+':'+delicious_post_pad0(d.getUTCSeconds(),2)+'Z';
		// clean up - destroy created instance (necessary?)
		delete d;
		// build the entire query string
		//var querystring = api_url+'posts/add?url='+url+'&description='+description+'&extended='+extended+'&tags='+tags+'&dt='+isodatestamp;
		//var querystring = api_url+'posts_add.php?url='+url+'&description='+description+'&extended='+extended+'&tags='+tags+'&dt='+isodatestamp;
		var privacy = scuttlelicious_get_privacy_level(document.getElementById('scuttlelicious-privacy-code'));
		
		if(privacy<0)
			privacy = 0;
		
		var querystring = api_url+'url='+url+'&description='+description+'&extended='+extended+'&tags='+tags+'&status='+privacy;
		
		dump("\n");
		dump(querystring);
		dump("\n");
		
		// start a new XMLHttpRequest 
		var xmlhttp = new XMLHttpRequest();
		var	status = false;
	
		// open the connection as synchronous, sending username/password as part of the HTTPAuth
		xmlhttp.open("GET",querystring,false,username,password);
		
		try {
			xmlhttp.send(null);
		} catch(e) {
			alert(bundle.getString('statusconnectionerror') + "\n" +
			//bundle.getString('status_access_url') + "  " + base_api_url + "\n" +
			bundle.getString('status_xml_url')	+ "  " + api_url);
			scuttlelicious_reset_dialog();
			return false;
		}
		
		
		try {
			dump("xmlhttp.status is " + xmlhttp.status + "\n");
			dump("xmlhttp.responseXML is " + xmlhttp.responseXML + "\n");
			
			switch(xmlhttp.status) {
				case 503:
					alert(bundle.getString('statusthrottled'));
					break;
				case 401:
				case 403:
					alert(bundle.getString('statusauthenticationfailed'));
					break;
				case 200:
					status=true;
				default:
					if(!scuttlelicious_isAddBookmarkSuccessful(xmlhttp)){
						alert(bundle.getString("statusadderror"));
						status=false;
					}
					break;
			}
		} catch (e) {
			alert(bundle.getString('statusconnectionerror') + "\n" +
				//bundle.getString('status_access_url') + "  " + base_api_url + "\n" +
				bundle.getString('status_xml_url')	+ "  " + api_url);
				status = false;

		}
		scuttlelicious_reset_dialog();
		
		return status;

	}


}


function delicious_autofillPassword(username) {
	if (document.getElementById('delicious-post-dialog-use_password_manager').checked==true) {
		password = delicious_getPassword(username);
		document.getElementById('delicious-post-dialog-password').setAttribute('value',password);
	}
}

// helper function to pad numbers to required length (http://www.propix.hu/www/Clock/Clock.html)
function delicious_post_pad0(string, newlength) {
  var pad = '';
  var len = newlength-String(string).length;
  var i;
  for (i = 0; i<len; i++) {
    pad += '0';
  }
  return pad+string;
}

function delicious_savePassword(username,password,save) {
	var url = scuttlelicious_chrome_url;

	if ("@mozilla.org/passwordmanager;1" in Components.classes) {
		var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance();
		if (passwordManager) {
		    passwordManager = passwordManager.QueryInterface(Components.interfaces.nsIPasswordManager);
		    if (save) {
			    try{
				    passwordManager.addUser(url, username, password);
		     	    } catch (e) { }
		    } else {
			    try{
				    passwordManager.removeUser(url, username);
			    } catch (e) { }
		    }
		}
	}
	else if ("@mozilla.org/login-manager;1" in Components.classes) {
		var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
	      	var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");

		if (passwordManager) {
			if (save) {
				try{
					// Find users for this extension 
					var logins = passwordManager.findLogins({}, url, url, null);
					// remove the older one
					for (var i = 0; i < logins.length; i++) {
						if (logins[i].username == username) {
							passwordManager.removeLogin(logins[i]);
							break;
						}
					}
					// Add the new login info
					var authLoginInfo = new nsLoginInfo(url, url, null, username, password, "", "");
					passwordManager.addLogin(authLoginInfo);			
				} catch (e) { }
			} else {
				try{
					// Find users for this extension 
					var logins = passwordManager.findLogins({}, url, url, null);

					for (var i = 0; i < logins.length; i++) {
						if (logins[i].username == username) {
							passwordManager.removeLogin(logins[i]);
							break;
						}
					}

				} catch (e) { }
			}	
		}
	}
}

function delicious_getPassword(username) {
  var url = scuttlelicious_chrome_url;
  if ("@mozilla.org/passwordmanager;1" in Components.classes) {
	  // Password Manager exists so this is not Firefox 3 (could be Firefox 2, Netscape, SeaMonkey, etc).
	  var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance(Components.interfaces.nsIPasswordManagerInternal);
	  var host = {value:""};
	  var user =  {value:""};
	  var password = {value:""};
	  passwordManager.findPasswordEntry(url, username, "", host, user, password);
	  return password.value
  }
  else if ("@mozilla.org/login-manager;1" in Components.classes) {
	  // Login Manager exists so this is Firefox 3
	  var passwordManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
	  var password = "" 
	  try {
		  var logins = passwordManager.findLogins({}, url, url, null);

		  for (var i = 0; i < logins.length; i++) {
			  if (logins[i].username == username) {
				  password = logins[i].password;
				  break;
			  }
		  }  
	  } catch(e){ }
	  return password; 
  }

  return ""
}


function scuttlelicious_autofillServiceURL() {
	var url = scuttlelicious_getServiceURL();
	document.getElementById('delicious-post-dialog-service-url').setAttribute('value',url);

}

function scuttlelicious_getServiceURL() {
	var url = "http://www.scuttle.org/";
	if(scuttlelicious_preferences.prefHasUserValue("scuttlelicious_host"))
		url = decodeURI(scuttlelicious_preferences.getCharPref("scuttlelicious_host"));
	return url;		
}

function scuttlelicious_isAddBookmarkSuccessful(xmlhttp){
	var dom = xmlhttp.responseXML
	
	var entries = dom.getElementsByTagName("result");
	
	if(!entries)
		return false;
		
	var node = entries[0];
	
	if(!node)
		return false;
		
	var result = node.getAttribute("code");
	
	return result == "done";
}

function scuttlelicious_reset_dialog(){
	document.getElementById('delicious-post-dialog').removeAttribute('wait-cursor');
	document.getElementById('delicious-post-dialog-deck').selectedIndex=0;
	document.getElementById('delicious-post-dialog-progress').hidden=true;
	document.getElementById('delicios-post-dialog-accept').disabled=false;
	document.getElementById('delicios-post-dialog-cancel').disabled=false;
				
}
